routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::middleware('auth:web')->group(function ()
{
	Route::get('/register', 'Auth\RegisterController@register')->name('register');
	Route::prefix('dashboard')->group(function ()
	{
		Route::get('/', 'PeminjamanController@index')->name('index');
		Route::get('/buku', 'BukuController@index')->name('buku');
		Route::get('/buku/tambah', 'BukuController@create')->name('buku.tambah');
		Route::post('/buku/tambah', 'BukuController@store')->name('buku.store');
		Route::get('/buku/ubah/{id}', 'BukuController@edit')->name('buku.ubah');
		Route::put('/buku/ubah/{id}', 'BukuController@update')->name('buku.update');
		Route::get('/buku/hapus/{id}', 'BukuController@update')->name('buku.hapus');
		Route::get('/buku/search/json', 'BukuController@searchJson')->name('buku.search.json');

		Route::resource('siswa', 'SiswaController');
		Route::get('/siswa', 'SiswaController@index')->name('siswa');
		Route::get('/siswa/{siswa}/destroy', 'SiswaController@destroy')->name('siswa.destroy');
		Route::get('/siswa/search/json', 'SiswaController@searchJson')->name('siswa.search.json');

		Route::get('peminjaman', 'PeminjamanController@index')->name('peminjaman');
		Route::get('peminjaman/tambah', 'PeminjamanController@create')->name('peminjaman.create');
	});
});

resources/views/buku-tambah.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')
    <script src="{{ asset('vendor/DataTables/datatables.min.js') }}"></script>
    <script>
        $("#data-buku").DataTable();
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <a href="{{ route('buku') }}" class="btn btn-primary">Back</a>
            <div class="card mt-4">
                <div class="card-body">
                    <h3>Tambah Buku</h3>
                    <form method="POST" action="{{ route('buku.store') }}" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">
                            <label>Judul</label>
                            <input type="text" class="form-control" name="judul" required="">
                        </div>
                        <div class="form-group">
                            <label>Jumlah Buku</label>
                            <input type="number" class="form-control" name="stok" required="">
                        </div>
                        <div class="form-group">
                            <label>Cover</label>
                            <input type="file" class="form-control" name="cover" required="">
                        </div>
                        <div class="form-group">
                            <label>Deskripsi</label>
                            <textarea class="form-control" name="deskripsi"></textarea>
                        </div>
                        <div class="form-group text-right">
                            <button class="btn btn-primary">Tambah</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/buku-ubah.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')
    <script src="{{ asset('vendor/DataTables/datatables.min.js') }}"></script>
    <script>
        $("#data-buku").DataTable();
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <a href="{{ route('buku') }}" class="btn btn-primary">Back</a>
            <div class="card mt-4">
                <div class="card-body">
                    <h3>Ubah Buku</h3>
                    <form method="POST" action="{{ route('buku.update', ['id' => $buku->id]) }}" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="form-group">
                            <label>Judul</label>
                            <input type="text" class="form-control" name="judul" value="{{ old('judul') ?? $buku->judul }}" required="">
                        </div>
                        <div class="form-group">
                            <label>Jumlah Buku</label>
                            <input type="number" class="form-control" name="stok" value="{{ old('stok') ?? $buku->stok }}" required="">
                        </div>
                        <div class="form-group">
                            <label>Cover</label>
                            <input type="file" class="form-control" name="cover">
                        </div>
                        <div class="form-group">
                            <label>Deskripsi</label>
                            <textarea class="form-control" name="deskripsi">{{ old('deskripsi') ?? $buku->deskripsi }}</textarea>
                        </div>
                        <div class="form-group text-right">
                            <button class="btn btn-primary">Tambah</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/buku.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')
    @foreach($bukus as $buku)
        <div class="modal fade" id="deleteBukuModal{{ $buku->id }}">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-body">
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                        <h3 class="text-center">
                            <i class="fas fa-exclamation-triangle text-danger"></i>
                            Hapus Buku
                        </h3>
                        Apakah anda yakin ingin menghapus buku <b>{{ $buku->judul }}</b>?
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Batal</button>
                        <a href="{{ route('buku.hapus', ['id' => $buku->id]) }}" class="btn btn-danger">Hapus</a>
                    </div>
                </div>
            </div>
        </div>
    @endforeach

    <script src="{{ asset('vendor/DataTables/datatables.min.js') }}"></script>
    <script>
        $("#data-buku").DataTable();
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">

                <div class="card-body">
                    <a href="{{ route('buku.tambah') }}" class="btn btn-success float-right">Tambah Buku</a>
                    <h3>Data Buku</h3>
                    <div class="table-responsive mt-5">
                        <table id="data-buku" class="table">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Cover</th>
                                    <th>Judul</th>
                                    <th>Deskripsi</th>
                                    <th>Stok</th>
                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($bukus as $buku)
                                    <tr>
                                        <td>{{ $buku->id }}</td>
                                        <td><img height="100" src="{{ Perfika::cover($buku->cover) }}"></td>
                                        <td>{{ $buku->judul }}</td>
                                        <td style="max-width: 200px">{{ Perfika::summaryStr($buku->deskripsi, 150) }}</td>
                                        <td>{{ Perfika::stock($buku) }}/{{ $buku->stok }}</td>
                                        <td>
                                            <a href="{{ route('buku') }}" class="btn btn-primary">Detail</a>
                                            <a href="{{ route('buku.ubah', ['id' => $buku->id]) }}" class="btn btn-success">Ubah</a>
                                            <button class="btn btn-danger" data-toggle="modal" data-target="#deleteBukuModal{{ $buku->id }}">Hapus</button>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/peminjaman-tambah.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/bootstrap-select/dist/css/bootstrap-select.min.css') }}">
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/ajax-bootstrap-select/dist/css/ajax-bootstrap-select.min.css') }}">
@endsection

@section('js')
    <script src="{{ asset('vendor/bootstrap-select/dist/js/bootstrap-select.min.js') }}"></script>
    <script src="{{ asset('vendor/ajax-bootstrap-select/dist/js/ajax-bootstrap-select.min.js') }}"></script>

    <script>
        $(".selectpicker-user")
            .selectpicker()
            .ajaxSelectPicker({
                ajax: {
                    url: '{{ route('siswa.search.json') }}',
                    method: "get",
                    dataType: 'JSON',
                    data: function () {
                        var params = {
                            q: '@{{{q}}}'
                        };
                        return params;
                    }
                },
                preprocessData: function (data) {
                    var i, l = data.length, array = [];
                    if (l) {
                        for (i = 0; i < l; i++) {
                            array.push($.extend(true, data[i], {
                                text : data[i].text,
                                value: data[i].value
                            }));
                        }
                    }
                    return array;
                },
                preserveSelected: true
            });


        $(".selectpicker-buku")
            .selectpicker()
            .ajaxSelectPicker({
                ajax: {
                    url: '{{ route('buku.search.json') }}',
                    method: "get",
                    dataType: 'JSON',
                    data: function () {
                        var params = {
                            q: '@{{{q}}}'
                        };
                        return params;
                    }
                },
                preprocessData: function (data) {
                    var i, l = data.length, array = [];
                    if (l) {
                        for (i = 0; i < l; i++) {
                            array.push($.extend(true, data[i], {
                                text : data[i].text,
                                value: data[i].value
                            }));
                        }
                    }
                    return array;
                },
                preserveSelected: true
            });
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <a href="{{ route('peminjaman') }}" class="btn btn-primary">Back</a>
            <div class="card mt-4">
                <div class="card-body">
                    <h3>Pinjam Baru</h3>
                    <form method="POST" action="{{ route('siswa.store') }}" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">
                            <label>Siswa</label>
                            <select class="selectpicker-user" data-live-search="true">
                                
                            </select>
                        </div>
                        <div class="form-group">
                            <label>Buku</label>
                            <select class="selectpicker-buku" data-live-search="true">
                                
                            </select>
                        </div>
                        <div class="form-group text-right">
                            <button class="btn btn-primary">Tambah</button>
                        </div>

                        <pre>TODO:
Tanggal Peminjaman (dan pengembalian?)</pre>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/peminjaman.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')
    <script src="{{ asset('vendor/DataTables/datatables.min.js') }}"></script>
    <script>
        $("#data-siswa").DataTable();
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">

                <div class="card-body">
                    <a href="{{ route('peminjaman.create') }}" class="btn btn-success float-right">Pinjam Baru</a>
                    <h3>Data Peminjaman</h3>
                    <div class="table-responsive mt-5">
                        <table id="data-siswa" class="table">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Peminjam</th>
                                    <th>Buku</th>
                                    <th>Waktu</th>
                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($peminjamans as $peminjaman)
                                    <tr>
                                        <td>{{ $peminjaman->id }}</td>
                                        <td>{{ $peminjaman->siswa->name }}</td>
                                        <td>{{ $peminjaman->buku->judul }}</td>
                                        <td>{{ date("d F Y, H:i A", strtotime($peminjaman->peminjaman)) }}</td>
                                        <td>
                                            <a href="#" class="btn btn-primary">Detail</a>
                                            <a href="#" class="btn btn-success">Ubah</a>
                                            <button class="btn btn-danger" data-toggle="modal" data-target="#deleteSiswaModal{{ $buku->id }}">Hapus</button>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/siswa-tambah.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')
    <script src="{{ asset('vendor/DataTables/datatables.min.js') }}"></script>
    <script>
        $("#data-buku").DataTable();
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <a href="{{ route('siswa') }}" class="btn btn-primary">Back</a>
            <div class="card mt-4">
                <div class="card-body">
                    <h3>Tambah Siswa</h3>
                    <form method="POST" action="{{ route('siswa.store') }}" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">
                            <label>Nama</label>
                            <input type="text" class="form-control" name="name" required="">
                        </div>
                        <div class="form-group">
                            <label>NIS</label>
                            <input type="text" class="form-control" name="nis" required="">
                        </div>
                        <div class="form-group text-right">
                            <button class="btn btn-primary">Tambah</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/siswa-ubah.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')

@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <a href="{{ route('siswa') }}" class="btn btn-primary">Back</a>
            <div class="card mt-4">
                <div class="card-body">
                    <h3>Ubah Siswa</h3>
                    <form method="POST" action="{{ route('siswa.update', ['id' => $siswa->id]) }}" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="form-group">
                            <label>Nama</label>
                            <input type="text" class="form-control" name="name" value="{{ old('name') ?? $siswa->name }}" required="">
                        </div>
                        <div class="form-group">
                            <label>NIS</label>
                            <input type="text" class="form-control" name="nis" value="{{ old('nis') ?? $siswa->nis }}" required="">
                        </div>
                        <div class="form-group text-right">
                            <button class="btn btn-primary">Ubah</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/siswa.blade.php
@extends('layouts.app')

@section('css')
    <link rel="stylesheet" type="text/css" href="{{ asset('vendor/DataTables/datatables.min.css') }}">
@endsection

@section('js')
    @foreach($siswas as $siswa)
        <div class="modal fade" id="deleteSiswaModal{{ $siswa->id }}">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-body">
                        <button type="button" class="close" data-dismiss="modal">&times;</button>
                        <h3 class="text-center">
                            <i class="fas fa-exclamation-triangle text-danger"></i>
                            Hapus Siswa
                        </h3>
                        <p>Apakah anda yakin ingin menghapus siswa <b>{{ $siswa->name }}</b>?</p>
                        <small class="text-danger">* Seluruh data peminjaman dari siswa <b>{{ $siswa->name }}</b> juga akan terhapus</small>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Batal</button>
                        <a href="{{ route('siswa.destroy', ['siswa' => $siswa->id]) }}" class="btn btn-danger">Hapus</a>
                    </div>
                </div>
            </div>
        </div>
    @endforeach

    <script src="{{ asset('vendor/DataTables/datatables.min.js') }}"></script>
    <script>
        $("#data-siswa").DataTable();
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            <div class="card">

                <div class="card-body">
                    <a href="{{ route('siswa.create') }}" class="btn btn-success float-right">Tambah Siswa</a>
                    <h3>Data Siswa</h3>
                    <div class="table-responsive mt-5">
                        <table id="data-siswa" class="table">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Nama</th>
                                    <th>Nis</th>
                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($siswas as $siswa)
                                    <tr>
                                        <td>{{ $siswa->id }}</td>
                                        <td>{{ $siswa->name }}</td>
                                        <td>{{ $siswa->nis }}</td>
                                        <td>
                                            <a href="{{ route('siswa') }}" class="btn btn-primary">Detail</a>
                                            <a href="{{ route('siswa.edit', ['siswa' => $siswa->id]) }}" class="btn btn-success">Ubah</a>
                                            <button class="btn btn-danger" data-toggle="modal" data-target="#deleteSiswaModal{{ $siswa->id }}">Hapus</button>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection